/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Dimension;

import sos.framework.SOSApplet;
import sos.framework.SOSApplication;
import sos.lib.logger.Logger;

/**
 * Classe racine de l'application. Peut etre lancee comme une Applet ou comme une application classique.
 * 
 * @author Camille AMBROSI
 *
 */
public class SOSProject extends Applet
{

	private static final long serialVersionUID			= 1L;
	

	
	/**
	 * Contructeur de la version Applet de l'application.
	 *
	 */
	public SOSProject()
	{
		try{
			// dimensionne et lance l'applet
			this.setSize(new Dimension(SOSApplet.APPLET_WIDTH, SOSApplet.APPLET_HEIGHT));
			this.setLayout(new BorderLayout());
			this.add(new SOSApplet(), BorderLayout.CENTER);
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "SOSProject()", ex);}
	}

	/**
	 * Constructeur de la version locale de l'application.
	 * 
	 * @param args Les arguments de la ligne de commande
	 */
	public static void main(String[] args)
	{
		try{		
			// lance le programme
			new SOSApplication(args);
		}catch(Exception ex) {Logger.fireError(SOSProject.class.getName(), "main()", ex);}
	}
	

}
