/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework;

import sos.framework.ressources.Lang;
import sos.framework.simulation.SEnv;
import sos.lib.logger.Logger;
import sos.lib.uicommon.UI;

/**
 * Classe qui represente le simulateur sous forme d'application locale.
 * 
 * @author Camille AMBROSI
 *
 */
public class SOSApplication
{

	
	
	public static final String APPLET_VERSION			= "1.007e";
	public static final String APPLET_TITLE				= "sos.project simulator v." + APPLET_VERSION;


	
	
	
	
	
	/**
	 * Construit le simulateur en version application locale.
	 * 
	 * @param args Les arguments de la ligne de commande
	 */
	public SOSApplication(final String[] args)
	{
		try{
	
			// on initialise l'interface graphique
			UI.init();
			
			// langue par défaut
			Lang.loadFrench();
			
			// nouvel environnement
			SEnv env = new SEnv();
			
			// affiche la fenetre
			env.getWindow().setVisible(true);
			env.getWindow().buildEditor(env);

			
		} catch (Exception ex) {Logger.fireError(this.getClass().getName(), "SOSApplication()", ex);}
	}

}
