/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.io;

import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;
import javax.swing.JOptionPane;

import sos.framework.simulation.SEnv;
import sos.lib.logger.Logger;

public class ExportIMG
{
	

	public static final void export(final SEnv env, final ImageWriter writer, final ImageWriteParam wp)
	{
		try{
			File file = new File( env.getPrefs().getExportFile() );
			BufferedImage image = env.getSimul().getResults().getActualImage().getNormalizedImage();
			
			file.delete();
			ImageOutputStream output = ImageIO.createImageOutputStream(file);
			writer.setOutput(output);
			writer.write(null, new IIOImage(image, null, null), wp);
			output.flush();
			output.close();

			JOptionPane.showMessageDialog(env.getWindow(), "Enregistrement terminé.", "Exporter l'image au format Image", JOptionPane.INFORMATION_MESSAGE);

		}catch(Exception ex){
			Logger.fireError(ExportIMG.class.getName(), "exportIMG()", ex);
			JOptionPane.showMessageDialog(env.getWindow(), "Erreur d'enregistrement : " + ex.getMessage(), "Exporter l'image au format Image", JOptionPane.ERROR_MESSAGE);
		}
	}

	


}
