/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.io;

import java.awt.Component;
import java.io.File;
import java.security.AccessControlException;

import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import sos.framework.simulation.SEnv;
import sos.framework.simulation.simul.SSimul;
import sos.lib.logger.Logger;

public class SOSInputOutput
{
	
	
	public static final int EXPORT_FORMAT_SOS			= 0;
	public static final int EXPORT_FORMAT_FITS			= 2;
	public static final int EXPORT_FORMAT_TXT			= 3;
	public static final int EXPORT_FORMAT_IMG			= 5;
	

	
	
	

	
	public static final boolean importSOS(final Component parent, final SSimul simul, final String strFileName) {return ImportSOS.load(parent, simul, true, strFileName);}
	
	public static final boolean importSRC(final Component parent, final SSimul simul) {return ImportSOS.load(parent, simul, false, null);}
	
	
	
	
	public static final void exportSOS(final SEnv env) {ExportSOS.export(env);}
	
	public static final void exportFITS(final SEnv env) {ExportFITS.export(env);}

	public static final void exportIMG(final SEnv env, final ImageWriter writer, final ImageWriteParam wp) {ExportIMG.export(env, writer, wp);}

	public static final void exportTXT(final SEnv env) {ExportTXT.export(env);}

	
	
	
	
	
	
	
	
	
	
	public static final File askForFileName(final Component parent, final String strButton, final String strTitle)
	{
		try{
			
			JFileChooser chooser = new JFileChooser();
			
			chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
			chooser.setDialogTitle(strTitle);
			chooser.setSelectedFile(null);
			//chooser.setFileFilter(new FileFilter());
			
			int retval = chooser.showDialog(parent, strButton);
		    if(retval == JFileChooser.APPROVE_OPTION){
		    	 File theFile = chooser.getSelectedFile();
		    	 if(theFile != null) return theFile;
		    }
		    
		}catch(Exception ex){
			if(ex instanceof AccessControlException){
				JOptionPane.showMessageDialog(parent ,"Impossible de parcourir les fichiers locaux depuis une Applet.\nPour cela, vous devez lancer l'application en local.", "Parcourir les fichiers", JOptionPane.OK_OPTION);
			}else{
				JOptionPane.showMessageDialog(parent ,"Impossible de parcourir les fichiers locaux.\nSi ce n'est pas le cas, lancez l'application en local.", "Parcourir les fichiers", JOptionPane.OK_OPTION);
				Logger.fireError(SOSInputOutput.class.getName(), "askForSaveFile()", ex);
			}
		}
		return null;
	}

	
	
	

}
