/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.maths;

/**
 * Classe regroupant diverses constantes mathematiques et physiques utiles.
 * 
 * @author cams
 *
 */
public class Constants
{

	
	// Planck
	public static final double	H		= 6.62606896e-34;			// J.s == kg.m[+2].s[-1]
	
	// Célérité
	public static final double	C		= 299792458;				// m.s[-1]

	// Boltzmann
	public static final double	K		= 1.3806504e-23;			// J/K == kg.m[+2].s[-2].K[-1]

	// PI
	public static final double	PI		= Math.PI;
	
	// Néper
	public static final double	E		= Math.E;
	
	// Charge elementaire
	public static final double	Q		= 1.602176487e-19;			// C == s.A

	// H * C
	public static final double	HC		= H * C;


	
	// Hz = s[-1]
	// Jy = 10[-26].W.m[-2].Hz[-1] = 10[-26].kg.s[-2]
	// W = kg.m[+2].s[-3]
	//
	//

	
}
