/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.maths.conversions.angles;


public class FromArcsec
{	
	
	/**
	 * Convertie un angle exprime en Arcseconde en un angle exprime en Radian.
	 * 
	 * @param teta L'angle en Arcseconde
	 * @return L'angle en Radian
	 */
	public static final double toRad(double teta)
	{
		return teta * 4.84813681109536e-6; // teta * (pi / 3600 / 180)
	}
	
	/**
	 * Convertie un angle exprime en Arcseconde en une exprimee en KiloParsec.
	 * 
	 * @param r L'angle en Arceseconde
	 * @param d La distance au point de calcul en KiloParsec
	 * @return La distance en KiloParsec
	 */
	public static final double toKpc(double r, double d)
	{
		return r * d * 4.84813681109536e-6; // r * d * (pi / 180 / 3600)
	}

}
