/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.maths.conversions.angles;


public class FromRad
{

	/**
	 * Convertie un angle exprime en Radian en un angle exprime en Arcseconde.
	 * 
	 * @param teta L'angle en Radian
	 * @return L'angle en Arcseconde
	 */
	public static final double toArcsec(double teta)
	{
		return teta * 206264.80624709636; // teta * (1 / pi * 3600 * 180)
	}

	/**
	 * Convertie un angle exprime en Radian en un angle exprime en Degre.
	 * 
	 * @param teta L'angle en Radian
	 * @return L'angle en Degre
	 */
	public static final double toDeg(double teta)
	{
		return teta * 57.29577951308232; // teta * 180.0 / pi
	}


}
