/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.maths.conversions.distances;


public class FromKpc
{

	/**
	 * Convertie une distance exprimee en KiloParsec en un angle exprime en Arcseconde.
	 * 
	 * @param r Le rayon de courbure
	 * @param d La distance au point de calcul en KiloParsec
	 * @return L'angle en Arcseconde
	 */
	public static final double toArcsec(double r, double d)
	{
		return r / d / 4.84813681109536e-6; // r / d / (pi * 180 * 3600)
	}

}
