/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.maths.conversions.flux;

import sos.framework.maths.conversions.solidangles.FromArcsecSq;
import sos.framework.simulation.simul.specs.SSpecImage;

public class FromElectPerPix
{

	public static final double toJyPerSterad(double flux_ElecPerPix, final SSpecImage image)
	{
		double pixres = image.getPixelResolution();
		return FromElect.toJy(flux_ElecPerPix, image) / FromArcsecSq.toSterad(pixres * pixres);
	}

	public static final double toJyPerPix(double flux_ElecPerPix, final SSpecImage image)
	{
		return FromElect.toJy(flux_ElecPerPix, image);
	}
	
	public static final double factorToJyPerSterad(final SSpecImage image)
	{
		double pixres = image.getPixelResolution();
		return FromElect.factorToJy(image) / FromArcsecSq.toSterad(pixres * pixres);
	}
	
}
