/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.maths.units;


public class DistanceUnit extends SAbstractUnit
{
	private static final int ID_METER				= 1;
	private static final int ID_MILLIMETER			= 2;
	private static final int ID_KILOMETER			= 3;
	
	
	
// GESTION DES UNITES
	
	public static final DistanceUnit METER = new DistanceUnit(ID_METER, "m", "metre");
	public static final DistanceUnit KILOMETER = new DistanceUnit(ID_KILOMETER, "km", "killometre");
	public static final DistanceUnit MILLIMETER = new DistanceUnit(ID_MILLIMETER, "mm", "millimetre");

	static{
		addEquivUnit(METER);
		addEquivUnit(KILOMETER);
		addEquivUnit(MILLIMETER);
	}
	
	
	
	
	
	
	
	
	
	
	
	private DistanceUnit(final int id, final String abbr, final String desc)
	{
		super(id, abbr, desc);
	}

	
	
	
	
	public final double getInMeters(final double value, final DistanceUnit unitFrom)
	{
		switch(unitFrom.id)
		{
			case ID_METER: 			return ( value );
			case ID_KILOMETER: 		return ( value * 1000.0 );
			case ID_MILLIMETER: 	return ( value / 1000.0 );
			default: return Double.NaN; 
			
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

}
