/*
  SOS Project Classes.

  Copyright (C) 2006 SOS Project <http://sos.project.free.fr>
  SOS Project is :
    Denis BURGARELLA @ OAMP <http://www.lam.oamp.fr/denis>
    Camille AMBROSI @ CMI <http://camille.ambrosi.free.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.framework.ressources;

import javax.swing.ImageIcon;

public class Icons
{
	
	// control bar
	public static final ImageIcon ICON_PROPERTIES_0		 				= loadIcon("iconProperties0.jpg");
	public static final ImageIcon ICON_PROPERTIES_1		 				= loadIcon("iconProperties1.jpg");
	public static final ImageIcon ICON_DISTRIBUTION_0 					= loadIcon("iconDistribution0.jpg");
	public static final ImageIcon ICON_DISTRIBUTION_1 					= loadIcon("iconDistribution1.jpg");
	public static final ImageIcon ICON_GENERATION_0						= loadIcon("iconGeneration0.jpg");
	public static final ImageIcon ICON_GENERATION_1						= loadIcon("iconGeneration1.jpg");
	public static final ImageIcon ICON_NOISIFICATION_0		 			= loadIcon("iconNoises0.jpg");
	public static final ImageIcon ICON_NOISIFICATION_1		 			= loadIcon("iconNoises1.jpg");
	public static final ImageIcon ICON_NORMALIZATION_0		 			= loadIcon("iconNormalization0.jpg");
	public static final ImageIcon ICON_NORMALIZATION_1					= loadIcon("iconNormalization1.jpg");
	public static final ImageIcon ICON_STUDIES_0		 				= loadIcon("iconStudies0.jpg");
	public static final ImageIcon ICON_STUDIES_1		 				= loadIcon("iconStudies1.jpg");
	
	// menu
	public static final ImageIcon MENU_PROPERTIES		 				= loadIcon("mnuProperties.png");
	public static final ImageIcon MENU_DISTRIBUTION		 				= loadIcon("mnuDistribution.png");
	public static final ImageIcon MENU_GENERATION		 				= loadIcon("mnuGeneration.png");
	public static final ImageIcon MENU_NOISES			 				= loadIcon("mnuNoises.png");
	public static final ImageIcon MENU_NORMALIZE		 				= loadIcon("mnuNormalization.png");
	public static final ImageIcon MENU_COLORIZE			 				= loadIcon("mnuColorization.png");
	public static final ImageIcon MENU_INFOS		 					= loadIcon("mnuAide.png");
	public static final ImageIcon MENU_ABOUT			 				= loadIcon("mnuAbout.png");
	public static final ImageIcon MENU_OPEN				 				= loadIcon("mnuOpen.png");
	public static final ImageIcon MENU_EXEMPLE			 				= loadIcon("mnuExemple.png");
	public static final ImageIcon MENU_CLOSE			 				= loadIcon("mnuClose.png");
	public static final ImageIcon MENU_SAVE				 				= loadIcon("mnuSave.png");
	public static final ImageIcon MENU_EXIT				 				= loadIcon("mnuExit.png");
	public static final ImageIcon MENU_DUPLICATE_IMAGE	 				= loadIcon("mnuDuplicateImage.png");
	public static final ImageIcon MENU_REMOVE_IMAGE_IMAGE	 			= loadIcon("mnuRemoveImage.png");
	public static final ImageIcon MENU_WINDOWS_HIDE			 			= loadIcon("mnuWindowsHide.png");
	public static final ImageIcon MENU_WINDOWS_SHOW	 					= loadIcon("mnuWindowsShow.png");
	public static final ImageIcon MENU_EXPORT				 			= loadIcon("mnuExport.png");
	
	// buttons
	public static final ImageIcon ICON_BUTTON_ADD						= loadIcon("iconButtonAdd.png");
	public static final ImageIcon ICON_BUTTON_REMOVE					= loadIcon("iconButtonRemove.png");
	public static final ImageIcon ICON_BUTTON_EDIT						= loadIcon("iconButtonEdit.png");
	public static final ImageIcon ICON_BUTTON_NOISE_UP					= loadIcon("iconButtonNoiseUp.png");
	public static final ImageIcon ICON_BUTTON_NOISE_DOWN				= loadIcon("iconButtonNoiseDown.png");
	public static final ImageIcon ICON_BUTTON_UP						= loadIcon("iconButtonUp.png");
	public static final ImageIcon ICON_BUTTON_RIGHT						= loadIcon("iconButtonRight.png");
	public static final ImageIcon ICON_BUTTON_LEFT						= loadIcon("iconButtonLeft.png");
	public static final ImageIcon ICON_BUTTON_CLOSE						= loadIcon("iconButtonClose.png");
	
	// various
	public static final ImageIcon ICON_START_SIMULATION					= loadIcon("iconStartSimulation.png");
	public static final ImageIcon ICON_STAGE_LOCKED						= loadIcon("iconStageLocked.png");
	public static final ImageIcon ICON_STAGE_NEEDED						= loadIcon("iconStageNeeded.png");
	
	// logos
	public static final ImageIcon LOGO_MAIN_470							= loadIcon("logoBlue470.jpg");
	public static final ImageIcon LOGO_FORMAT_SOS						= loadIcon("logoSOS.png");

	

	private static final ImageIcon loadIcon(final String strName)
	{
		try{
			return new ImageIcon(Icons.class.getResource("icons/"+strName));
		}catch(Exception ex) {}
		return null;
	}

}
