/*
 SOS Project Classes.

 Copyright (C) SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.framework.ressources;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;

import sos.lib.logger.Logger;

public class SOSResources
{
	


	public static final String loadFileContent(final InputStream in)
	{
		try{
			BufferedReader r = new BufferedReader(new InputStreamReader(in));
			
			// lit les donnees
			String line = null;
			StringBuffer lines = new StringBuffer("");
			while( (line = r.readLine()) != null ){
				lines.append(line + "\n");
			}
			return lines.toString();
		}catch(Exception ex) {Logger.fireError(SOSResources.class.getName(), "loadFileContent()", ex);}
		return null;
	}

	
	
	
	public static final BufferedReader getJARFileReader(final String strFileName)
	{
		try{
			return new BufferedReader(new InputStreamReader(SOSResources.class.getResourceAsStream(strFileName)));
		}catch(Exception ex) {Logger.fireError(SOSResources.class.getName(), "getDistribFile()", ex);}
		return null;
	}
	
	
	public static final BufferedReader getJARDistribFileReader(final String strFileName)
	{
		try{
			return getJARFileReader("distrib/"+strFileName);
		}catch(Exception ex) {Logger.fireError(SOSResources.class.getName(), "getDistribFile()", ex);}
		return null;
	}
	
	public static final BufferedReader getJARExFileReader(final String strFileName)
	{
		try{
			return getJARFileReader("ex/"+strFileName);
		}catch(Exception ex) {Logger.fireError(SOSResources.class.getName(), "getJARExFileReader()", ex);}
		return null;
	}
	
	public static final BufferedReader getLocalFileReader(final String strFileName)
	{
		try{
			return new BufferedReader(new InputStreamReader(new FileInputStream(strFileName)));
		}catch(Exception ex) {Logger.fireError(SOSResources.class.getName(), "getLocalFileReader()", ex);}
		return null;
	}
	
	
	
	
}
