/*
 SOS Project Classes.

 Copyright (C) SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.framework.simulation.prefs;

import java.util.Vector;

import sos.lib.logger.Logger;


public class SPrefs
{

	private static final long serialVersionUID 				= 1L;
	
	
	
	
	

	/* largeur de mesure */
 	public int UTILS_INTENSITY_MEASURE_WIDTH				= 1;
 	
 	
 	public static final int DISPLAY_MODE_HORIZONTAL			= 1;
 	public static final int DISPLAY_MODE_VERTICAL			= 2;

 
 	
 	
 	
 	
 	
 	
 	
	public SPrefs()
	{
		try{
			initPrefs();
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "SPrefs()", ex);}
		
	}
	
	public void initPrefs()
	{
		setZoomFactor(1.0);
		setDisplayedObjectsNumber(0);
	}
	
	
	
	
	
	

	
	
	
// LISTENERS //
		
		
	// les ecouteurs
	private Vector lstListeners								= new Vector();

	// ecouteurs
	public final void addPrefsListener(final _SPrefsListener listener) {lstListeners.add(listener);}
	public final void removePrefsListener(final _SPrefsListener listener) {lstListeners.remove(listener);}

	private final void firePreferencesChanged() {for(int i=0; i<lstListeners.size(); i++) try{ ((_SPrefsListener)(lstListeners.get(i))).onPreferencesChanged(); }catch(Exception ex) {}}


	
	
	
	
	
	
// EXPORT //
	
	private String strExportFile							= null;
	public final String getExportFile() {return strExportFile;}
	public final void setExternalFile(final String strExportFile) {this.strExportFile = strExportFile;} 
	
	private String strImageFormat							= null;
	public final String getImageFormat() {return strImageFormat;}
	public final void setImageFormat(final String strFormat) {this.strImageFormat = strFormat;} 

	private boolean blExportRawValues						= true;
	public final boolean getExportRawValues() {return blExportRawValues;}
	public final void setExportRawValues(final boolean blExportRawValues) {this.blExportRawValues = blExportRawValues;} 

	private boolean blExportNormalizedValues				= false;
	public final boolean getExportNormalizedValues() {return blExportNormalizedValues;}
	public final void setExportNormalizedValues(final boolean blExportNormalizedValues) {this.blExportNormalizedValues = blExportNormalizedValues;} 
	
	private boolean blExportAllImages						= true;
	public final boolean getExportAllImages() {return blExportAllImages;}
	public final void setExportAllImages(final boolean blExportAllImages) {this.blExportAllImages = blExportAllImages;} 
	
	private boolean blExportSources							= true;
	public final boolean getExportSources() {return blExportSources;}
	public final void setExportSources(final boolean blExportSources) {this.blExportSources = blExportSources;} 
	
	private boolean blExportSpecs							= true;
	public final boolean getExportSpecs() {return blExportSpecs;}
	public final void setExportSpecs(final boolean blExportSpecs) {this.blExportSpecs = blExportSpecs;} 

	
	

	
	
	
	
// MODE D'AFFICHAGE //
	
 	
 	/* facteur de zoom */
 	private int iOrientation								= DISPLAY_MODE_HORIZONTAL;
 	
 	public final int getOrientation() {return iOrientation;}
 	
 	public final void setOrientation(final int iOrientation)
 	{
 		if(this.iOrientation != iOrientation){
 			this.iOrientation = iOrientation;
 			firePreferencesChanged();
 		}
 	}
 	
 	
 	
 	
	
	
	
	
// ZOOM //

	
 	// facteur de zoom
 	private double dblZoomFactor							= 0;
 	
 	public final double getZoomFactor() {return dblZoomFactor;}
 	
 	public final void setZoomFactor(final double dblZoomFactor)
 	{
 		if(this.dblZoomFactor != dblZoomFactor){
 			this.dblZoomFactor = dblZoomFactor;
 			firePreferencesChanged();
 		}
 	}

	
	
 	
// NOMBRE D'OBJETS A AFFICHER //
	
 	
 	// facteur de zoom
 	private int iNbObjects									= 0;
 	
 	public final int getDisplayedObjectsNumber() {return iNbObjects;}
 	
 	public final void setDisplayedObjectsNumber(final int iNbObjects)
 	{
 		if(this.iNbObjects != iNbObjects){
 			this.iNbObjects = iNbObjects;
 			firePreferencesChanged();
 		}
 	}
 	

	
	
	

 	
 	
 	
 	

}

