/*
 SOS Project Classes.

 Copyright (C) SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.framework.simulation.simul.results;

import java.awt.image.BufferedImage;
import java.util.Vector;

import sos.framework.simulation.simul.SSimul;
import sos.lib.logger.Logger;

public class SResults
{

	
	private SSimul simul									= null;

	
	
	

	
	public SResults(final SSimul simul)
	{
		this.simul = simul;
	}

	public final void dispose()
	{
		try{
			simul = null;
			lstImages.clear(); lstImages = null;
			imageColor = null;
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "dispose()", ex);}
	}
	

	
	
	
	
	
	
	
// IMAGES //

	// la liste des matrices generees
	private Vector lstImages								= new Vector();
	
	public final Vector getImages() {return lstImages;}
	
	// retourne une image
	public final SResultImage getImageAt(final int i)
	{
		try{
			return (SResultImage)(lstImages.get(i));
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "getImageAt()", ex);}
		return null;
	}

	public final SResultImage getActualImage()
	{
		try{
			return (SResultImage)(lstImages.get(simul.getActualImageNumber()));
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "getImageAt()", ex);}
		return null;
	}


	
	
	
// IMAGE COULEUR //

	private BufferedImage imageColor							= null;
	
	public final BufferedImage getColorImage() {return imageColor;}

	public final void setColorImage(final BufferedImage imageColor) {this.imageColor = imageColor;}
	


}

