/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.simulation.simul.specs.filters;

import java.util.Vector;

import sos.lib._SModificationListener;
import sos.lib.logger.Logger;


public class SFilter
{

	
	private String strDescription							= null;
	
	private double dblLambdaCenter							= 0.0;
	private double dblLambdaDelta							= 0.0;


	
	
	
	
	
	public SFilter(final String strDescription, final double dblLambdaCenter, final double dblLambdaDelta)
	{
		this.strDescription = strDescription;
		this.dblLambdaCenter = dblLambdaCenter;
		this.dblLambdaDelta = dblLambdaDelta;
	}
	
	
	
	
	
	
	/* les ecouteurs */
	private Vector lstListeners								= new Vector();

	/* ecouteurs */
	public final void addModificationListener(final _SModificationListener listener) {lstListeners.add(listener);}
	public final void removeModificationListener(final _SModificationListener listener) {lstListeners.remove(listener);}

	private final void fireFilterModified() {for(int i=0; i<lstListeners.size(); i++) try{ ((_SModificationListener)(lstListeners.get(i))).onModificated(this); }catch(Exception ex) {}}

	public final boolean isLocked() {return (lstListeners.size() > 0);}

	
	
	
	
	
	
	public final String getDescription() {return strDescription;}
	
	public final void setDescription(final String newVal) {this.strDescription = newVal;}
	
	public final String toString() {return getDescription();}
	
	
	
	

	
	
	public final double getLambdaCenter() {return dblLambdaCenter;}
	
	public final void setLambdaCenter(final double dblLambdaCenter)
	{
		try{
			if( this.dblLambdaCenter != dblLambdaCenter ){
				this.dblLambdaCenter = dblLambdaCenter;
				fireFilterModified();
			}
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "setLambdaCenter()", ex);}
	}
	
	

	
	
	public final double getLambdaDelta() {return dblLambdaDelta;}
	
	public final void setLambdaDelta(final double dblLambdaDelta)
	{
		try{
			if( this.dblLambdaDelta != dblLambdaDelta ){
				this.dblLambdaDelta = dblLambdaDelta;
				fireFilterModified();
			}
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "setLambdaDelta()", ex);}
	}
	

	public boolean isBlackFilter() {return (dblLambdaCenter <= 0.0);}
	

	
	
	
/*
	public final boolean equals(final Object other) {return false;}
	public final boolean equals(final SFilter other)
	{
		if( this.dblLambdaCenter != other.getLambdaCenter() ) return false;
		if( this.dblLambdaDelta != other.getLambdaDelta() ) return false;
		return true;
	}
	*/
	
	
}
