/*
 SOS Project Classes.

 Copyright (C) SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.framework.simulation.simul.specs.noises;

import java.util.Vector;

import sos.lib._SModificationListener;
import sos.lib.logger.Logger;


public class SNoise
{

	private boolean blApplyForEachPixel								= true;

	private String strDescription							= null;
	
	private String strFunction								= null;
	


	
	
	public SNoise(final String strDescription, final String strFunction, final boolean blApplyForEachPixel)
	{
		this.strDescription = strDescription;
		this.strFunction = strFunction;
		this.blApplyForEachPixel = blApplyForEachPixel;
	}
	
	
	
	
	

	private Vector lstListeners								= new Vector();

	public final void addModificatioListener(final _SModificationListener listener) {lstListeners.add(listener);}
	
	public final void removeModificationListener(final _SModificationListener listener) {lstListeners.remove(listener);}

	private final void fireNoiseModified() {for(int i=0; i<lstListeners.size(); i++) try{ ((_SModificationListener)(lstListeners.get(i))).onModificated(this); }catch(Exception ex) {}}

	public final boolean isLocked() {return (lstListeners.size() > 0);}

	
	
	
	
	
	
	
	public final String getDescription() {return strDescription;}
	
	public final void setDescription(final String newVal) {this.strDescription = newVal;}
	
	public final String toString() {return getDescription();}
	
	
	
	
	
	
	
	public final String getFunction() {return strFunction;}
	
	public final void setFunction(final String strFunction)
	{
		try{
			String str = strFunction;
			if( str == null ) str = "";
			if( str.equalsIgnoreCase(this.strFunction) == false ){
				this.strFunction = str;
				fireNoiseModified();
			}
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "setFunction()", ex);}
	}
	
	
	
	
	
	public final boolean getApplyForEachPixel() {return blApplyForEachPixel;}
	
	public final void setApplyForEachPixel(final boolean blIsGlobal)
	{
		try{
			if( this.blApplyForEachPixel != blIsGlobal ){
				this.blApplyForEachPixel = blIsGlobal;
				fireNoiseModified();
			}
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "setGlobal()", ex);}
	}
	
	
	


	
/*
	public final boolean equals(final Object other)
	{
		if( (other instanceof SNoise) == false ) return false;
		SNoise noise = (SNoise)other;
		if( this.blIsGlobal != noise.blIsGlobal ) return false;
		if( this.iUnitID != noise.getUnit().getID() ) return false;
		if( this.strFunction == null && noise.getFunction() == null ) return true;
		if( this.strFunction == null && noise.getFunction() != null ) return false;
		if( this.strFunction.equals(noise.getFunction()) == false ) return false;
		return true;
	}
	*/
}
