/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.simulation.simul.specs.sources;

import java.util.StringTokenizer;
import java.util.Vector;


public class SSourcesContainer
{

	private static final long serialVersionUID 				= 1L;
	
	public static final int DISTRIBUTION_TYPE_FUNCTION		= 2;
	public static final int DISTRIBUTION_TYPE_SCRIPT		= 3;
	

	
	
	
	
	
	
	
	public SSourcesContainer()
	{
	
		
	}
	
	
	
	
	
	
	
	
	
	
// POSSIBILITE DE redistribution //
	/*
	private boolean blIsLocked								= true;
	
	public final boolean isLocked() {return blIsLocked;}
	
	public final boolean canRedistribute()
	{
		if( (blIsLocked == false) || (lstComponents.size() == 0) ) return true;
		return false;
	}
	
	public final void setLocked(final boolean blIsLocked) {this.blIsLocked = blIsLocked;}
	
	
	
	
	
	*/
	
	

// ORIGINE //
	
	private String strSourcesOrigin								= "-";
	
	public final String getSourcesOrigin() {return strSourcesOrigin;}
	
	public final void setSourcesOrigin(final String strSourcesOrigin) {this.strSourcesOrigin = strSourcesOrigin;}
	
	
	
	

	
	
	
	
	
// COMPOSANTS //
	
	
	/* les composants de l'image */
	private Vector lstComponents							= new Vector();

	
	public final synchronized void addSource(final SSource source)
	{
		lstComponents.add(source);
	}
	
	public final synchronized void addSource(final String source)
	{
		String str = source.substring(1, source.length() - 1);
		StringTokenizer st = new StringTokenizer(str, ";");
		double x = Double.parseDouble( st.nextToken() );
		double y = Double.parseDouble( st.nextToken() );
		double flux = Double.parseDouble( st.nextToken() );
		lstComponents.add(new AiryPoint(x, y, flux));
	}	
	
	public final synchronized int getSourcesCount()
	{
		return lstComponents.size();
	}
	
	public final synchronized SSource getSourceAt(final int i)
	{
		return (SSource)(lstComponents.get(i));
	}
	
	public final synchronized void clearSources()
	{
		lstComponents.clear();
	}
	




}

