/*
 SOS Project Classes.

 Copyright (C) SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.framework.ui.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;
import javax.swing.JTextArea;

import sos.framework.io.ExportTXT;
import sos.framework.ressources.Lang;
import sos.framework.simulation.SEnv;
import sos.framework.simulation.simul._SSpecsListener;
import sos.framework.ui.SOSDialog;
import sos.lib.logger.Logger;
import sos.lib.uicommon.UI;

public class InformationDialog extends SOSDialog implements _SSpecsListener
{

	private static final long serialVersionUID 			= 1L;

	private JTextArea txt								= null;

	private SEnv env									= null;
	

	
	public InformationDialog(final SEnv env)
	{
		super(env.getWindow(), Lang.STR_TITLE_INFORMATIONS, true, false, BUTTONS_CLOSE);
		try{
			this.env = env;
			// construit le contenu
			txt = UI.createTextArea("-");
			txt.setEditable(false);
			txt.setFont(UI.FONT_PLAIN_MONOSPACED);
			GridBagConstraints c = new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(3, 3, 0, 3), 0, 0);
			JPanel pnlGridBag = UI.createPanel(new GridBagLayout());
			pnlGridBag.add(UI.createScrollPane(txt , new Dimension(460, 380)), c);
			setContent(pnlGridBag);
			this.env.getSimul().addSimulationListener(this);
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "InformationDialog()", ex);}
	}

	private final void fillContent()
	{
		try{
			txt.setText(ExportTXT.exportTXTSpecs(env, true));
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "fillContent()", ex);}
	}


	
	public void setVisible(final boolean blVisible)
	{
		if(blVisible == true) fillContent();
		super.setVisible(blVisible);
	}
	
	
	
	

	public void onSimulationImageChanged()
	{
		//if(this.isVisible() == false) return;
		//fillContent();
	}

	public void onSimulationStateChanged(boolean blIsSimulating)
	{
		if(this.isVisible() == false) return;
		if(blIsSimulating == true) txt.setText("");
		else fillContent();
	}
	public void onSimulationStageChanged(int iSimulationState) {}


}
