/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.framework.ui.editor.controlbar;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;

import sos.lib.logger.Logger;


public class BarStartZone extends JButton implements MouseListener
{

	private static final long serialVersionUID			= 1L;
	
	private boolean blOver								= false;



	
 	public BarStartZone(final ActionListener lst, final String strTitle, final ImageIcon ic)
 	{
 		super("");
 		try{
 			this.setToolTipText(strTitle);
			this.setPreferredSize(ControlBar.START_DIMENSION);
			this.setMaximumSize(ControlBar.START_DIMENSION);
			this.setMinimumSize(ControlBar.START_DIMENSION);
			this.setOpaque(true);
			this.setBackground(Color.lightGray);
			this.setIcon(ic);
			this.addActionListener(lst);
 			this.addMouseListener(this);
 			this.setLayout(null);
 			this.setBorder(null);
 			this.setMargin(new Insets(0, 0, 0, 0));
 		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "BarStartZone()", ex);}
 	}


 	public final void paint(Graphics g)
 	{
 		super.paint(g);
 		if(blOver){
 			g.setColor(Color.black);
 			g.drawRect(0, 0, ControlBar.START_DIMENSION.width-1, ControlBar.START_DIMENSION.height-1);
 	 		g.drawRect(0, 0, ControlBar.START_DIMENSION.width-2, ControlBar.START_DIMENSION.height-2);
 		}
 	}
 	
    public final void mouseEntered(MouseEvent e)
    {
    	blOver = true;
    	this.repaint();
    }
    
    public final void mouseExited(MouseEvent e)
    {
    	blOver = false;
    	this.repaint();
    }
 	
    
    
    
    
 	public final void mouseClicked(MouseEvent e) {}
    public final void mousePressed(MouseEvent e) {}
    public final void mouseReleased(MouseEvent e) {}


}
