/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.fitswriter;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Vector;




public class FitsFile
{

	public static final int FITS_HDU_BYTE_SIZE					= 2880;
	public static final int FITS_HEADER_CARD_SIZE				= 80;
	public static final int FITS_HEADER_KEYWORD_SIZE			= 8;
	public static final int FITS_HEADER_VALUE_SIZE				= 20;
	public static final int FITS_HEADER_COMMENT_SIZE			= 47;
	
	
	
	
	

	private Vector lstHDUs					= null;
	
	
	
	
	
	public FitsFile()
	{
		lstHDUs = new Vector();
	}
	
	
	
	
	public final int getHDUsNumber()
	{
		return lstHDUs.size(); 
	}
	
	public final FitsHDU getHDUAt(final int index)
	{
		return (FitsHDU)(lstHDUs.get(index));
	}
	
	public final void addHDU(final FitsHDU hdu)
	{
		lstHDUs.add(hdu);
	}
	
	
	
	
	
	
	
	public final boolean write(final File file)
	{
		try{
			
			FitsOutputStream out = new FitsOutputStream( new FileOutputStream(file) );
			
			for(int i=0; i<getHDUsNumber(); i++){
				if( !(getHDUAt(i).write(out, (i==0)) ) ) return false;
			}
			
			if( !out.flush() ) return false;
			if( !out.close() ) return false;

			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	
	
	
	
}
