/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.fitswriter;




public class FitsHDU
{

	private FitsHeader header							= null;
	private FitsImageData data							= null;
	
	
	
	
		
	public FitsHDU(final FitsHeader header, final FitsImageData data)
	{
		this.data = data;
		this.header = header;
	}

	
	
	public FitsImageData getData()
	{
		return data;
	}
	
	public void setData(FitsImageData data)
	{
		this.data = data;
	}
	
	
	
	public FitsHeader getHeader()
	{
		return header;
	}

	public void setHeader(FitsHeader header)
	{
		this.header = header;
	}
	
	
	
	
	
	
	
	public final boolean write(final FitsOutputStream out, final boolean blPrimary)
	{
		try{
			
			if( !(header.write(out, blPrimary) ) ) return false;
			
			if( !(out.completeTo(FitsFile.FITS_HDU_BYTE_SIZE, (byte)' ') ) ) return false;
			out.resetWrittenBytes();
			
			if( !(data.write(out) ) ) return false;
			
			if( !(out.completeTo(FitsFile.FITS_HDU_BYTE_SIZE, (byte)0) ) ) return false;
			out.resetWrittenBytes();

			return true;
		}catch(Exception ex) {}
		return false;
	}
	   
	  

}
