/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.fitswriter;

import java.util.Vector;



public class FitsHeader
{

	private Vector lstCards					= null;
	
	
	
	
	
	public FitsHeader()
	{
		lstCards = new Vector();
	}
	
	
	
	
	public final int getCardsNumber()
	{
		return lstCards.size(); 
	}
	
	public final FitsHeaderCard getCardAt(final int index)
	{
		return (FitsHeaderCard)(lstCards.get(index));
	}
	
	public final void addCard(final FitsHeaderCard card)
	{
		lstCards.add(card);
	}
	
	
	
	
	
	public final boolean write(final FitsOutputStream out, final boolean blPrimary)
	{
		try{

			if(blPrimary){
				if( !(new FitsHeaderCard("SIMPLE", true, "Standard primary HDU")).write(out) ) return false;
			}else{
				if( !(new FitsHeaderCard("XTENSION", "IMAGE   ", "Standard extension")).write(out) ) return false;
			}
			
			if( !(new FitsHeaderCard("BITPIX", -64, "IEEE double precision floating point")).write(out) ) return false;
			if( !(new FitsHeaderCard("NAXIS", 2, "Number of data axes")).write(out) ) return false;
			
			for(int i=0; i<getCardsNumber(); i++){
				if( !getCardAt(i).write(out) ) return false;
			}
			
			if(blPrimary){
				if( !(new FitsHeaderCard("EXTEND", true, "Extensions are permitted")).write(out) ) return false;
			}else{
				if( !(new FitsHeaderCard("PCOUNT", 0, "No parameters")).write(out) ) return false;
				if( !(new FitsHeaderCard("GCOUNT", 1, "One group")).write(out) ) return false;
			}
			
			if( !(new FitsHeaderCard("ORIGIN", "SOS Simulator", null)).write(out) ) return false;
			if( !(new FitsHeaderCard("END")).write(out) ) return false;

			if( !out.flush() ) return false;
			
			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	
	
	
	
	
}
