/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.fitswriter;




public class FitsImageData
{
	
	private double[][] data						= null;
	
	
	
	public FitsImageData(final double[][] data)
	{
		this.data = data;
	}



	
	
	public double[][] getData()
	{
		return data;
	}
	
	
	
	
	public final boolean write(final FitsOutputStream out)
	{
		try{

			byte[] value = new byte[8];
	
			for(int x=0; x<data.length; x++){
				for(int y=0; y<data[0].length; y++){
				
					long val = Double.doubleToLongBits( data[x][y] );
					
					int val1 = (int)(val >>> 32);
					int val2 = (int)val;
					value[0] = (byte)(val1 >>> 24);
					value[1] = (byte)(val1 >>> 16);
					value[2] = (byte)(val1 >>>  8);
					value[3] = (byte)(val1       );
					value[4] = (byte)(val2 >>> 24);
					value[5] = (byte)(val2 >>> 16);
					value[6] = (byte)(val2 >>> 8 );
					value[7] = (byte)(val2       );

					if( !out.write( value ) ) return false;

				}
			}
			
			if( !out.flush() ) return false;
	
			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	
	
	
}
