/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.fitswriter;

import java.io.OutputStream;




public class FitsOutputStream
{
	
	private OutputStream out				= null;
	private int written						= 0;
	
	
	
	
	
	
	public FitsOutputStream(final OutputStream out)
	{
		this.out = out;
	}
	
	
	
	
	
	public final void resetWrittenBytes()
	{
		written = 0;
	}
	
	public final int getWrittenBytes()
	{
		return written;
	}
	
	public final boolean completeTo(int nbWantedByte, byte value)
	{
		try{
			int add = nbWantedByte - written;
			if(add > 0){
				byte[] buff = new byte[add];
				for(int i=0; i<add; i++) buff[i] = value;
				this.write(buff);
			}
			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	
	
	
	
	
	public final boolean write(byte[] data)
	{
		try{
			written += data.length;
			if(written >= FitsFile.FITS_HDU_BYTE_SIZE) written -= FitsFile.FITS_HDU_BYTE_SIZE;
			out.write(data);
			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	public final boolean flush()
	{
		try{
			out.flush();
			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	public final boolean close()
	{
		try{
			out.close();
			return true;
		}catch(Exception ex) {}
		return false;
	}
	
	

}
