/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.logger;

import java.awt.Component;
import java.util.Vector;

import javax.swing.JOptionPane;

import sos.lib.SOSReplace;
import sos.lib._SLogsListener;


public class Logger
{

	private static int iLogRank									= 0;
	
 	private static Vector lstListeners							= new Vector();
	
	
	
	
 	
 	
	public Logger() {}
	
	
	
	
	
	
	
	

	public static final void addLogsListener(final _SLogsListener listener) {lstListeners.add(listener);}
	
	public static final void removeLogsListener(final _SLogsListener listener) {lstListeners.remove(listener);}

	
	
	
	
	
	
	
	
	public static final boolean check(final boolean cond, final String assertName)
	{
		if(!cond) fireLog("ASSERT FAILED : " + assertName);
		return cond;
		
	}
	
	
	
	
	
	
	
	
	public static final void initLog()
	{
		fireLog("");
		fireLog(" ********** Nouvelle simulation **********");
		iLogRank = 1;
	}
	
	public static final void beginLog(final String strLog)
	{
		fireLog(getBegining() + strLog);
		iLogRank++;
	}	
	
	public static final void log(final String strLog)
	{
		fireLog(getBegining() + strLog);
	}
	
	public static final void endLog(final boolean blSuccess)
	{
		iLogRank--;
		if(blSuccess) fireLog(getBegining() + ". ok.");
		else fireLog(getBegining() + ". erreur.");

	}

	private static final void fireLog(final String strLog)
	{
		for(int i=0; i<lstListeners.size(); i++){
			try{
				((_SLogsListener)(lstListeners.get(i))).onLog(strLog + "\n");
			}catch(Exception ex) {}
		}
	}
	
	
	
	private static final String getBegining()
	{
		String begin = " ";
		for(int i=0; i<iLogRank; i++) begin = begin + ". ";
		return begin;
	}
	
	
	


	
	public static final void fireError(String strClass, String strFunc, Exception e)
	{
		try{
			System.out.println("** Java Exception ** " + strClass + "_" + strFunc + " : " + e.getClass().getName());
			System.out.println("-- Stack trace --");
			e.printStackTrace();
			System.out.println("-- End stack trace --");
		}catch(Exception ex) {}
	}
	
	
	
	
	
	public static final void notifyError(final Component cpn, final String strMessage, final String strTitle)
	{
		try{
			JOptionPane.showMessageDialog(cpn, strMessage, strTitle, JOptionPane.ERROR_MESSAGE);
		}catch(Exception ex) {Logger.fireError(SOSReplace.class.getName(), "notifyError()", ex);}
	}

	public static final void notifyInfo(final Component cpn, final String strMessage, final String strTitle)
	{
		try{
			JOptionPane.showMessageDialog(cpn, strMessage, strTitle, JOptionPane.INFORMATION_MESSAGE);
		}catch(Exception ex) {Logger.fireError(SOSReplace.class.getName(), "notifyInfo()", ex);}
	}
	
	
	
	
	
	

}

