package sos.lib.mathparser;




public class Reader
{
	
	public Reader(String str)
	{
		this.str = str;
		this.len = str.length();
		readChar();
		nextWord();
	}

	private String str;
	private int offset = 0;
	private int len;
	
	private int lastType;
	
	private String lastStr = "";
	private double lastDouble = 0.0;
	
	private char lastChar = 0;
	
	
	
	
	public int lastType()
	{
		return lastType;
	}
	
	public double lastNb()
	{
		if( (lastType == ParsedExpr.TYPE_NB) && (lastStr.length() > 0) ) return lastDouble;
		else return Double.NaN;
	}
	
	public String lastVar()
	{
		if( (lastType == ParsedExpr.TYPE_VAR) && (lastStr.length() > 0) ) return lastStr;
		else return "";
	}
	
	
	
	
	public void nextWord()
	{
		//System.out.println("nextW");
		lastStr = "";
		if(lastChar == 0) {lastType = ParsedExpr.TYPE_END; return;}
		
		switch(lastChar){
			case '+': lastType = ParsedExpr.TYPE_PLUS; readChar(); return;
			case '-': lastType = ParsedExpr.TYPE_MINUS; readChar(); return;
			case '*': lastType = ParsedExpr.TYPE_TIMES; readChar(); return;
			case '/': lastType = ParsedExpr.TYPE_DIVIDES; readChar(); return;
			case '(': lastType = ParsedExpr.TYPE_BRAOPEN; readChar(); return;
			case ')': lastType = ParsedExpr.TYPE_BRACLOSE; readChar(); return;
			case '[': lastType = ParsedExpr.TYPE_CROOPEN; readChar(); return;
			case ']': lastType = ParsedExpr.TYPE_CROCLOSE; readChar(); return;
			case ',': lastType = ParsedExpr.TYPE_VIRG; readChar(); return;
			case '|': lastType = ParsedExpr.TYPE_OR; readChar(); return;
			case '&': lastType = ParsedExpr.TYPE_AND; readChar(); return;
			case '^': lastType = ParsedExpr.TYPE_POWER; readChar(); return;
		}

		if( lastChar == '!' ){
			readChar();
			if( lastChar == '=' ) {lastType = ParsedExpr.TYPE_DIFF; readChar();}
			else lastType = ParsedExpr.TYPE_NO;
			return;
		}
		
		if( lastChar == '>' ){
			readChar();
			if( lastChar == '=' ) {lastType = ParsedExpr.TYPE_SUPEGAL; readChar();}
			else lastType = ParsedExpr.TYPE_SUP;
			return;
		}
		
		if( lastChar == '<' ){
			readChar();
			if( lastChar == '=' ) {lastType = ParsedExpr.TYPE_INFEGAL; readChar();}
			else if( lastChar == '>' ) {lastType = ParsedExpr.TYPE_DIFF; readChar();}
			else lastType = ParsedExpr.TYPE_INF;
			return;
		}
		
		if( lastChar == '=' ){
			readChar();
			if( lastChar == '=' ) {lastType = ParsedExpr.TYPE_EGALEGAL; readChar();}
			else if( lastChar == '>' ) {lastType = ParsedExpr.TYPE_SUPEGAL; readChar();} 
			else if( lastChar == '<' ) {lastType = ParsedExpr.TYPE_INFEGAL; readChar();} 
			else lastType = ParsedExpr.TYPE_EGAL;
			return;
		}

		while( lastChar>='0' && lastChar<='9' ){
			lastStr = lastStr + lastChar; readChar();
		}
		if(lastStr.length() > 0){
			if( lastChar == '.' ){
				lastStr = lastStr + lastChar; readChar();
				while( lastChar>='0' && lastChar<='9' ){
					lastStr = lastStr + lastChar; readChar();
				}
			}
			if( lastChar == 'e' || lastChar == 'E' ){
				lastStr = lastStr + lastChar; readChar();
				if( lastChar == '+' || lastChar == '-' ) {lastStr = lastStr + lastChar; readChar();}
				while( lastChar>='0' && lastChar<='9' ){
					lastStr = lastStr + lastChar; readChar();
				}
			}
			try{
				lastDouble = Double.parseDouble(lastStr);
				lastType = ParsedExpr.TYPE_NB;	
			}catch(Exception e) {lastType = ParsedExpr.TYPE_ERROR;}
			return;
		}
		
		while( (lastChar == '.') || (lastChar == '}') || (lastChar == '_') || (lastChar>='a' && lastChar<='z') || (lastChar>='0' && lastChar<='9') ){
			lastStr = lastStr + lastChar;
			readChar();
		}
		if(lastStr.length() > 0){
			lastType = ParsedExpr.TYPE_VAR;
			return;
		}
		
	}
	
	
	private void readChar()
	{
		do{
			if(offset < len) lastChar = str.charAt(offset); 
			else lastChar = 0;
			offset++;
		}while(lastChar == ' ' || lastChar == '\n' || lastChar == '\r' || lastChar == '\t');
	}
	
	
}
