/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.mathparser.functions.conversions;

import sos.framework.maths.conversions.flux.FromJyPerSterad;
import sos.framework.simulation.simul.specs.SSpecImage;
import sos.lib.mathparser.functions.Function;

public class ConvJySteradToElecPix extends Function
{
	
	private SSpecImage image = null;
	
	public ConvJySteradToElecPix(final String name, final SSpecImage image) {super(name); this.image = image;}

	public double computeValue() throws Exception
	{
		if(params.length != 1) throw new Exception("eval : la fonction '" + name + "' requiert 1 parametre");
		return FromJyPerSterad.toElecPerPix(params[0], image);
	}
	
}
