package sos.lib.mathparser.nodes;

import java.util.Vector;

import sos.framework.maths.Maths;
import sos.lib.mathparser.ParsedExpr;
import sos.lib.mathparser.functions.Function;


public class NodeFct extends Node
{

	private Vector params = new Vector();
	
	public Vector getParams() {return params;}
	
	public void addParam(Node node) {params.add(node);}
	
	
	
	private String name;
	
	public String getName() {return name;}
	
	
	
	

	public NodeFct(ParsedExpr express, String name)
	{
		super(express);
		this.name = name;
		this.iType = ParsedExpr.TYPE_FCT;
	}
	
	
	
	
	
	public void compile() throws Exception
	{
		this.value = Double.NaN;
		
		for(int i=0; i<params.size(); i++) ((Node)(params.get(i))).compile();

		if(name.equalsIgnoreCase("iif")){
			if(params.size() != 3) throw new Exception("eval : la fonction 'iif' requiert 3 parametres");
			if(((Node)(params.get(0))).value() == 0.0) this.value = ((Node)(params.get(2))).value();
			else this.value = ((Node)(params.get(1))).value();
			return;
		}

		if(name.equalsIgnoreCase("not")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'not' requiert 1 parametre");
			if(((Node)(params.get(0))).value() == 0.0) this.value = 1.0;
			else this.value = 0.0;
			return;
		}
		
		if(name.equalsIgnoreCase("abs")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'abs' requiert 1 parametre");
			this.value = Math.abs( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("round")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'round' requiert 1 parametre");
			this.value = Math.round( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("ceil")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'ceil' requiert 1 parametre");
			this.value = Math.ceil( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("floor")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'floor' requiert 1 parametre");
			this.value = Math.floor( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("log")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'log' requiert 1 parametre");
			this.value = Maths.log( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("ln")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'ln' requiert 1 parametre");
			this.value = Maths.ln( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("exp")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'exp' requiert 1 parametre");
			this.value = Math.exp( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("sqrt")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'sqrt' requiert 1 parametre");
			this.value = Math.sqrt( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("pow")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'pow' requiert 2 parametres");
			this.value = Math.pow( ((Node)(params.get(0))).value(), ((Node)(params.get(1))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("fact")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'fact' requiert 1 parametre");
			this.value = Maths.factorial( (int)((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("sin")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'sin' requiert 1 parametre");
			this.value = Math.sin( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("cos")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'cos' requiert 1 parametre");
			this.value = Math.cos( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("tan")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'tan' requiert 1 parametre");
			this.value = Math.tan( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("asin")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'asin' requiert 1 parametre");
			this.value = Math.asin( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("acos")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'acos' requiert 1 parametre");
			this.value = Math.acos( ((Node)(params.get(0))).value() );
			return;
		}
		
		if(name.equalsIgnoreCase("atan")){
			if(params.size() != 1) throw new Exception("eval : la fonction 'atan' requiert 1 parametre");
			this.value = Math.atan( ((Node)(params.get(0))).value() );
			return;
		}

		Function func = parser.getFunction(name);
		if(func != null){
			double[] doubles = new double[params.size()];
			for(int i=0; i<doubles.length; i++) doubles[i] = ((Node)(params.get(i))).value();
			func.setParams(doubles);
			this.value = func.computeValue();
			return;
		}

		throw new Exception("eval : fonction '" + name + "' inconnue");
	}
	

	
}
