package sos.lib.mathparser.nodes;

import java.util.Vector;

import sos.lib.mathparser.ParsedExpr;




public class NodeOp extends Node
{

	private Vector children = new Vector();
	
	public Vector getChildren() {return children;}
	
	public void addChild(Node node) {children.add(node);}
	
	
	
	
	public NodeOp(ParsedExpr express, int iType)
	{
		super(express);
		this.iType = iType;
	}
	
	

	public void compile() throws Exception
	{
		this.value = Double.NaN;

		for(int i=0; i<children.size(); i++) ((Node)(children.get(i))).compile();

		switch(iType){
			case ParsedExpr.TYPE_PLUS:
				if(children.size() != 2) throw new Exception("eval : la fonction '+' requiert 2 parametres");
				value = ((Node)(children.get(0))).value() + ((Node)(children.get(1))).value();
				return;
			case ParsedExpr.TYPE_MINUS:
				if(children.size() == 1) value = -((Node)(children.get(0))).value(); 
				else if(children.size() == 2) value = ((Node)(children.get(0))).value() - ((Node)(children.get(1))).value();
				else throw new Exception("eval : la fonction '-' requiert 1 ou 2 parametres");
				return;
			case ParsedExpr.TYPE_TIMES:
				if(children.size() != 2) throw new Exception("eval : la fonction '*' requiert 2 parametres");
				value = ((Node)(children.get(0))).value() * ((Node)(children.get(1))).value();
				return;	
			case ParsedExpr.TYPE_DIVIDES:
				if(children.size() != 2) throw new Exception("eval : la fonction '/' requiert 2 parametres");
				value = ((Node)(children.get(0))).value() / ((Node)(children.get(1))).value();
				return;
			case ParsedExpr.TYPE_POWER:
				if(children.size() != 2) throw new Exception("eval : la fonction '^' requiert 2 parametres");
				value = Math.pow( ((Node)(children.get(0))).value() , ((Node)(children.get(1))).value() );
				return;
			case ParsedExpr.TYPE_EGALEGAL:
				if(children.size() != 2) throw new Exception("eval : la fonction '==' requiert 2 parametres");
				value = (((Node)(children.get(0))).value()== ((Node)(children.get(1))).value()?1.0:0.0);
				return;
			case ParsedExpr.TYPE_SUPEGAL:
				if(children.size() != 2) throw new Exception("eval : la fonction '>=' requiert 2 parametres");
				value = (((Node)(children.get(0))).value()>= ((Node)(children.get(1))).value()?1.0:0.0);
				return;
			case ParsedExpr.TYPE_INFEGAL:
				if(children.size() != 2) throw new Exception("eval : la fonction '<=' requiert 2 parametres");
				value = (((Node)(children.get(0))).value()<= ((Node)(children.get(1))).value()?1.0:0.0);
				return;
			case ParsedExpr.TYPE_SUP:
				if(children.size() != 2) throw new Exception("eval : la fonction '>' requiert 2 parametres");
				value = (((Node)(children.get(0))).value() > ((Node)(children.get(1))).value()?1.0:0.0);
				return;
			case ParsedExpr.TYPE_INF:
				if(children.size() != 2) throw new Exception("eval : la fonction '<' requiert 2 parametres");
				value = (((Node)(children.get(0))).value() < ((Node)(children.get(1))).value()?1.0:0.0);
				return;
			case ParsedExpr.TYPE_OR:
				if(children.size() != 2) throw new Exception("eval : la fonction '|' requiert 2 parametres");
				value = ((((Node)(children.get(0))).value()!=0.0)||(((Node)(children.get(1))).value()!=0.0)?1.0:0.0);
				return;
			case ParsedExpr.TYPE_AND:
				if(children.size() != 2) throw new Exception("eval : la fonction '&' requiert 2 parametres");
				value = ((((Node)(children.get(0))).value()!=0.0)&&(((Node)(children.get(1))).value()!=0.0)?1.0:0.0);
				return;
			case ParsedExpr.TYPE_NO:
				if(children.size() != 1) throw new Exception("eval : la fonction '!' requiert 1 parametres");
				value = (((Node)(children.get(0))).value()==0.0?1.0:0.0);
				return;
		}
		
		throw new Exception("eval : operation du type " + iType + " inconne");
	}
	

	
}
