/*
 SOS Project Classes.

 Copyright (C) SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.lib.uicommon;

import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.JComboBox;


public class SOSComboBox extends JComboBox implements MouseWheelListener 
{

	private static final long serialVersionUID				= 1L;
	
	
	public SOSComboBox(final Object[] strData)
	{
		super(strData);
		this.addMouseWheelListener(this);
	}
	
	
	public SOSComboBox()
	{
		super();
		this.addMouseWheelListener(this);
	}

	
	public void mouseWheelMoved(MouseWheelEvent e)
	{
		try{
			int iNewIndex = this.getSelectedIndex() + e.getWheelRotation();
			if(iNewIndex < 0) iNewIndex = 0;
			if(iNewIndex > (this.getItemCount()-1)) iNewIndex = (this.getItemCount()-1);
			this.setSelectedIndex(iNewIndex);
		}catch(Exception ex) {}
	}
	

}
