/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.uicommon;

import java.awt.Font;
import java.awt.Insets;

import javax.swing.JEditorPane;

public class SOSRichTextPane extends JEditorPane
{
	
	private static final long serialVersionUID 	= 1L;
	
	public SOSRichTextPane()
	{
		this.setMargin(new Insets(5, 0, 5, 5));
		this.setFont(new Font("Monospaced", Font.PLAIN, this.getFont().getSize()));
	}
	
	public void setPlainText(String str)
	{
		this.setEditable(true);
		this.setContentType("text/plain");
		this.setText(str);
	}
	
	public void setHTMLText(String str)
	{
		this.setContentType("text/html");
		this.setText("<html><font face=\"monospaced\">"+str+"</font></html>");
		this.setEditable(false);
	}
	
}