/*
 SOS Project Classes.

 Copyright (C) 2006-2008 SOS Project <http://sos.project.free.fr>
 SOS Project is Denis BURGARELLA and Camille AMBROSI.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sos.lib.uicommon;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.JTextField;


public class SOSTextField extends JTextField
{

	private static final long serialVersionUID				= 1L;
	
	private String strUnit									= null;
	private int iUnitMaxWidth								= -1;
	

	
	
	public SOSTextField(final String strText)
	{
		super(strText);
	}
	
	
	public SOSTextField(final String strText, final String strUnit)
	{
		super(strText);
		this.strUnit = strUnit;
	}
	
	
	public final void paint(final Graphics g)
	{
		super.paint(g);
		
		if(strUnit != null){
			
			if(iUnitMaxWidth < 0){
				this.iUnitMaxWidth = this.getGraphics().getFontMetrics().stringWidth(strUnit);
				this.setMargin(new Insets(0, 0, 0, iUnitMaxWidth+8));
			}
			

			//g.setColor(Color.lightGray);
			g.setColor(new Color(240, 240, 240));
			//g.setColor(Color.black);
			g.fillRect(this.getWidth()-iUnitMaxWidth-8, 2, iUnitMaxWidth+5, this.getHeight()-5);
			
			g.setColor(Color.black);
			//g.setColor(new Color(240, 240, 240));
			g.drawString(strUnit, this.getWidth()-iUnitMaxWidth-6, this.getHeight()-6);
		
		}

	}
	
	
	
	
	
}
