/*
  SOS Project Classes.

  Copyright (C) SOS Project <http://sos.project.free.fr>
  SOS Project is :
    Denis BURGARELLA @ OAMP <http://www.lam.oamp.fr/denis>
    Camille AMBROSI @ CMI <http://camille.ambrosi.free.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package sos.lib.uicommon.graphics;

import java.awt.Color;

import sos.lib.logger.Logger;

public abstract class SFunction
{
	
	private String strName										= null;
	private String strDesc										= null;
	private Color color											= null;


	public SFunction(final String strName, final String strDesc, final Color color)
	{
		try{
			this.strName = strName;
			this.strDesc = strDesc;
			this.color = color;
		}catch(Exception ex) {Logger.fireError(this.getClass().getName(), "SFunction()", ex);}
	}
	
	
	public abstract double yValue(final double xValue);
	

	public final String getName() {return strName;}
	public final void setName(final String strName) {this.strName = strName;}

	
	public final String getDescription() {return strDesc;}
	public final void setDescription(final String strDesc) {this.strDesc = strDesc;}

	
	public final Color getColor() {return color;}
	public final void setColor(final Color color) {this.color = color;}

	
	public final String toString() {return getName();}

}
